package config

import (
	"acme-mana-server-go/util"
	"fmt"
)

func init() {
	initConfig()
}

type Server struct {
	Host string
	Port string
}

type Db struct {
	File string
}

type Admin struct {
	username string
	password string
}

type SysConfig struct {
	Server Server
	Db     Db
	Admin  Admin
}

var conf *SysConfig

func GetConfig() *SysConfig {
	return conf
}

func initConfig() {
	port := util.GetEnv("ACME_SERVER_PORT", "8080")
	server := Server{
		Host: util.GetEnv("ACME_SERVER_HOST", "0.0.0.0"),
		Port: port,
	}
	db := Db{
		File: util.GetEnv("ACME_DB_FILE", "acme-mane.db"),
	}
	admin := Admin{
		username: util.GetEnv("ACME_ADMIN_USERNAME", "acme-admin"),
		password: util.GetEnv("ACME_ADMIN_PASSWORD", "acme-pass"),
	}
	conf = &SysConfig{
		Server: server,
		Db:     db,
		Admin:  admin,
	}
	fmt.Println(conf)
}
