package service

import (
	"acme-mana-server-go/acme"
	"acme-mana-server-go/dao"
	"acme-mana-server-go/model"
	"acme-mana-server-go/vo"
)

type DomainService struct {
}

var domainDao = &dao.DomainDao{}
var acmeUserService = &AcmeUserService{}

func (_ *DomainService) Get(id int) *model.Domain {
	return domainDao.Get(id)
}
func (_ *DomainService) List() *[]model.Domain {
	return domainDao.List()
}
func (_ *DomainService) Add(domain *model.Domain) *model.Domain {
	return domainDao.Add(domain)
}
func (_ *DomainService) Edit(domain *model.Domain) *model.Domain {
	return domainDao.Edit(domain)
}
func (_ *DomainService) Delete(id int) {
	domainDao.Delete(id)
}

func (_ *DomainService) Page(req *vo.DomainPageReq) (int64, *[]model.Domain) {
	return domainDao.Page(req)
}

func (service *DomainService) Apply(id int) {
	domain := service.Get(id)
	acmeUser := acmeUserService.Get(int(domain.AcmeUserId))
	resource := acme.Apply(domain, acmeUser)
	json := acme.ResourceToJson(resource)
	domain.Resource = string(json)
}
